#!/usr/bin/perl -w
# quickbull.pl
# Auteur: Jean-Marie Pacquet
#
# il met  jour les cotations  partir de la liste des valeurs
#
use Getopt::Std;
use DateTime;
use URI;
use LWP;
use HTTP::Cookies;
use HTTP::Request::Common qw(POST);
use HTML::Entities ();
use DBI;
use strict;

###############################################################################
#
# paramtres pour cet essai:
#
my @valrep; # tableau des donnes de valeurs rpertories
my $valeur; # numro de la valeur dans la table valeurs
my $libelle = "";
my $isin = "";
my $cotation = 0; # mode d'obtention du cours de la valeur
my $prefixe = ""; # prefixe pour la place de cotation
my $mnemo = ""; # code mnemo de la valeur sur sa place de cotation
my $suffixe = ""; # suffixe du mnemo
my $symbole = ""; # cl de recherche de la valeur (prefixe+mnemo+suffixe)
my $classe;
#
my $cote = ""; # cote du jour
my $date; # jour de cote au format aaaa-mm-jj
my $aaaa;
my $mm;
my $jj;
my $and; # anne sur deux chiffres du jour de cote
my $cotedavant; # cote dj enregistre
my $ccount = 0; # nombre de mises  jour de cotations
#
my $requete;
my $url;
my $buffer;
# date du jour
my ($sec,$min,$heure,$jour,$mois,$an,$js,$ja,$hiv) = localtime(time);
my $ann; # anne du jeu sur deux chiffres
$ann = $an - 100; # extraction des deux derniers chiffres de l'anne en cours
$an += 1900; # normalisation de l'anne
$mois++; #      et du mois
if ($mois < 10) {
    $mm = '0' . $mois;
} else {
    $mm = $mois;
}
if ($jour < 10) {
    $jj = '0' . $jour;
} else {
    $jj = $jour;
}
my $hui = $an . "-" . $mm . "-" . $jj;
my $maj = $hui;
my $dthui = DateTime->today();
my $dtmaj = $dthui;
# Rcuprer les options de la ligne de commande
our($opt_d,$opt_x);
if (getopts('dx:')) {
    print "Debug\n" if ($opt_d);
} else {
    die "usage: quickbull.pl [-d] -x nn\n";
}
if ($opt_x) {
    $ann = $opt_x;
}
if ($ann < 10) {
    $ann = "0" . $ann;
}
print "quickbull.pl $ann\n";
#
my $debut = "20" . $ann . "-01-01";
# Gestion des cookies
my $cookie_jar = HTTP::Cookies->new();

# Cration du navigateur (user agent)
my $ua = LWP::UserAgent->new();
$ua->cookie_jar( $cookie_jar );

# On le fait passer pour Mozilla Firefox
$ua->agent("Mozilla/5.0 (X11; U; Linux i686; rv:6.0.2) Gecko/20100101 Firefox/6.0.2");
#$ua->agent("Lynx/2.8.7rel.1 libwww-FM/2.14 SSL-MM/1.4.1 OpenSSL/0.9.8r");

#
# Visite de la page d'accueil
#
my $reponse = $ua->get("http://www.boursorama.com");
# Contrle de la rponse
#if ($reponse->is_success) {
    $cookie_jar->extract_cookies($reponse); # rcupration des cookies
#} else {
#        die "Erreur accueil: " . $reponse->status_line . "\n";
#}
#
# Ouvrir la base de donnes
#
my $pdbh = DBI->connect('DBI:Pg:dbname=thebull',
		       'login',
		       'password',
		       {
			   AutoCommit => 0

		       }
		       ) or die "Erreur de connexion  la base: " . DBI->errstr;
if ($opt_d) {
    print "PgSQL thebull connected\n"; # debug
}
#
# prparation des requtes SQL
#
my $valeursnn = "valeurs" . $ann;
my $select_valeurs = $pdbh->prepare("SELECT isin,valeur,libelle,mnemo,symbole,classe FROM $valeursnn");
my $cotationsnn = "cotations" . $ann;
my $select_cote = $pdbh->prepare("SELECT cote FROM $cotationsnn WHERE valeur = ? and jour = ?");
my $insert_cote = $pdbh->prepare("INSERT INTO $cotationsnn (valeur,cote,jour) VALUES (?,?,?)");
my $update_cote = $pdbh->prepare("UPDATE $cotationsnn SET cote = ? WHERE valeur = ? AND jour = ?");
my $resultatsnn = "resultats" . $ann;
my $delete_results = $pdbh->prepare("DELETE FROM $resultatsnn WHERE jour >= ?");
#
# prparer la recherche d'une valeur substitue  une valeur donne
#
my $ostnn = "ost" . $ann;
my $select_substituee = $pdbh->prepare("SELECT substitut,multiplicateur,diviseur,reste FROM $ostnn where valeur = ?");
#
# prparer la recherche d'une valeur de substitution
#
my $subcount;
my @substituee; # tableau de rsultat de la requte $select_substitution
my $select_substitution = $pdbh->prepare("SELECT valeur,multiplicateur,diviseur,reste,jour FROM $ostnn where substitut = ?");
#
# prparer la recherche des valeurs substitues  une date donne
#
my $select_substituees = $pdbh->prepare("SELECT DISTINCT valeur FROM $ostnn where jour <= ?");
my $valsub; # rsultat de la requte select_substituees

die "Impossible de prparer les requtes des inscrits\n"
    unless defined $select_valeurs
    && defined $select_cote
    && defined $insert_cote
    && defined $update_cote
    && defined $delete_results
    && defined $select_substituee && defined $select_substitution
    && defined $select_substituees;
#
# prparation d'une recherche de cours (Google)
#
$url = URI->new('http://www.boursorama.com/cours.phtml');
$url->query_form( 'symbole' => 'GOOG');
$requete = HTTP::Request->new(GET => $url);
$cookie_jar->add_cookie_header($requete) ;
$reponse = $ua->request($requete);
# Contrle de la rponse
if ($reponse->is_success) {
    $cookie_jar->extract_cookies($reponse); # rcupration des cookies
} else {
        die "Erreur recherche: " . $reponse->status_line . "\n";
}
#
# boucle de recherche de cotation pour chaque valeur de la base
#
my $pointeur;
my $premier;
my $dernier;
my $variation;
my $notfound = 0;
my $tried = 0;
my $beta = 0;
#
$select_valeurs->execute();
while ( @valrep = $select_valeurs->fetchrow_array() ) {
    $tried++;
    $isin = $valrep[0];
    $valeur = $valrep[1];
    $libelle = $valrep[2];
    $mnemo = $valrep[3];
    $symbole = $valrep[4];
    $classe = $valrep[5];
    # debug: filtrage sur la valeur
#    if ($valeur != 739) {
#	$tried--;
#	next;
#    }
    #
    # filtrage des valeurs non mises  jour (classe = X)
    if ($classe eq 'X') {
	next;
    }
    # filtrage des valeurs substitues
    $select_substituee->execute($valeur);
    if ($select_substituee->rows > 0) {
	print "$libelle: Valeur substitue\n";
	next;
    }
    # dtection des valeurs de substitution
    $select_substitution->execute($valeur);
    $subcount = $select_substitution->rows;
    if ($subcount > 0) {
	print "$libelle: Valeur de remplacement pour $subcount valeurs\n";
    }
#
    print $libelle . "\t(" . $valeur .")";
    if ($opt_d) {
	print "\tsymbole=" . $symbole . "\n"; # debug
    }
    if ($symbole) {
	$url = URI->new('http://www.boursorama.com/cours.phtml');
	$url->query_form( 'symbole' => $symbole);
    } else {
	$url = URI->new('http://www.boursorama.com/recherche/index.phtml');
	if ($beta) {
	    $url->query_form( 'search-query' => $isin);
	} else {
	    $url->query_form( 'search[query]' => $isin,
			  'search[type]' => 'rapide' );
	}
    }
    $requete = HTTP::Request->new(GET => $url);
    $cookie_jar->add_cookie_header($requete) ;
    $reponse = $ua->request($requete);
    # Contrle de la rponse
    if (!($reponse->is_success)) {
	print "Erreur cours: " . $reponse->status_line . "\n";
	next;
    }
    # rcupration de la rponse
    $buffer = $reponse->content;
    # exploitation des informations reues
    if ($buffer =~ /<meta http-equiv=\"X-UA-Compatible\" content=\"IE=Edge\" \/>/) {
	$beta = 1;
    } else {
	$beta = 0;
    }
    if (($beta and ($buffer =~ /<title>Moteur/)) or 
        (not $beta and ($buffer =~ /<meta name=\"description\" content=\"Retrouvez en/))) {
	#
	# la valeur n'est pas trouve avec les donnes de la base
	#
	print "Non trouve\n";
	$notfound++;
    } else {
	$dernier = index($buffer,"class=\"InfB\""); # valable depuis le 20/04/2009
	if ($dernier > 0) {
	    $pointeur = index($buffer,"\"gras\"",$dernier); # modifi le 20/04/2009
	    if ($pointeur > 0 ) { # correction du 24/08/2008
		$pointeur = index($buffer,">",$pointeur) + 1;
		$cote = substr($buffer,$pointeur,1); #03dec10
		if ($cote =~ /\D/ ) { #03dec10
		    $pointeur += 5; #03dec10
		}; #03dec10
	    }
	} else {
	    $dernier = index($buffer,"class=\"cotation\""); # valable depuis le 21/09/2011
	    if ($dernier > 0 ) {
		$pointeur = index($buffer,">",$dernier) + 1;
	    } else {
		$pointeur = -1;
		print substr($buffer,1,1000); # debug
		next; # debug
	    }
	}
	if (($pointeur > 0) and (substr($buffer,$pointeur,2) ne 'ND')) {
	    $cote = substr($buffer,$pointeur,10);
	    $cote =~ s/ //; # recolle le chiffre des milliers
	    if ($cote =~ /([0-9\.]+)/) {
		$cote = $1;
	    }
	} else {
	    $cote = '';
	}
	#
	# rcuprer le pourcentage de variation
	# et la date de la dernire cotation
	#
	$date = '';
	$dernier = index($buffer,"%",$pointeur);
	if ($dernier > 0) {
	    $premier = index($buffer,">",$dernier - 10) + 1;
	    $variation = substr($buffer,$premier,($dernier - $premier));
#03dec10	    $dernier = index($buffer,"%</span></strong>",$dernier + 1);
	    $dernier = index($buffer,"Dernier change",$dernier + 1); #03dec10
	    if ($dernier > 0) {
#03dec10		$dernier = index($buffer,"<li>",$dernier);
		$dernier = index($buffer,"<td>",$dernier); #03dec10
		if ($dernier > 0) {
		    $date = substr($buffer,$dernier + 4,8);
		}
	    } else {
		$dernier = index($buffer,"<td>&nbsp;Date</td>",$premier);
		if ($dernier > 0) {
		    $dernier = index($buffer,"<strong>",$dernier);
		    if ($dernier > 0) {
			$date = substr($buffer,$dernier + 8,6) . substr($buffer,$dernier + 16,2);
		    }
		}
	    }
	} else {
	    $variation = '';
	}
	if ($beta) {
	    print "\tBCote=" . $cote . "\t";
	} else {
	    print "\tCote=" . $cote . "\t";
	}
	if ($opt_d) {
	    print "Variation=" . $variation . "%\t";
	}
	if (($date ne '') and (substr($date,2,1) eq '/')) {
	    print "le " . $date . "\n";
	    # Formatage du jour en date SQL
	    $and = substr($date,6,2);
	    $date = "20" . $and . "-" . substr($date,3,2) . "-" . substr($date,0,2);
	    if ($date gt $hui) {
		print "date dans le futur!\n";
		next;
	    }
	    if ($date lt $debut) {
		print "date prime!\n";
		next;
	    }
	} else {
	    # pas de date pour la cotation: on prend la date du jour
	    # si la cote est positive et si c'est aprs 9h
	    # et qu'on est en semaine (Lu-Ve) et que ce n'est pas un jour fri
	    if (($cote > 0) and ($heure > 9) and ($js > 0 and $js < 7) and not($jour == 26 and $mois == 12)) {
		$date = "20" . $ann . "-" . $mois . "-" . $jour;
		print "le " . $date . "\n";
	    } else {
		print "sans date de cotation!\n";
		next;
	    }
	}
	#
	# Mise  jour de la table des cotations si ncessaire
	#
	$select_cote->execute($valeur,$date);
	if ($select_cote->rows == 0) {
	    if ($opt_d) {
		print "Pas de cote existante pour la valeur " . $valeur ." le " . $date . "\n";
	    }
	    if ($cote ne '') {
		$insert_cote->execute($valeur,$cote,$date);
		$ccount += 1;
	    } else {
		print "Pas de cotation\n";
	    }
	} else {
	    if ($cote ne '') {
		$cotedavant = $select_cote->fetchrow_array();
		if ($cote != $cotedavant) {
		    if ($and eq $ann) {
			print "Modification de la cote pour la valeur $valeur\n";
			$update_cote->execute($cote,$valeur,$date);
			$ccount += 1;
			($aaaa, $mm, $jj) = split('-',$date);
			my $dtcote = DateTime->new(year => $aaaa, month => $mm, day => $jj,)->truncate(to => 'day');
			if ($dtcote < $dtmaj) {
			    $maj = $date;
			    $dtmaj = $dtcote->clone();
			}
		    } else {
			print "La cote d'origine ($cotedavant) de la valeur $valeur est diffrente de celle releve ($cote)\n";
		    }
		}
	    }
	}
	if ($subcount > 0) {
	    #
	    # Mise  jour des cotations des valeurs substitues
	    #
	    print "Calcul des cotes pour les valeurs substitues\n";
	    print $date . "\n"; # debug
	    # slection des valeurs substitues  cette date
	    $select_substituees->execute($date);
	    while ( $valsub = $select_substituees->fetchrow_array() ) {
		print "valsub = " . $valsub . "\n"; # debug
		# Est-ce qu'on l'a dj enregistre?
		$select_cote->execute($valsub,$date);
		if ($select_cote->rows == 0) {
		    $cote = 0;
		    my $manque = 0;
		    $select_substituee->execute($valsub);
		    while ( @substituee = $select_substituee->fetchrow_array() ) {
			# chercher la cote de la valeur de substitution
			$select_cote->execute($substituee[0],$date);
			if ($select_cote->rows == 0) {
			    $manque = 1; # pas de calcul possible s'il manque une cote
			    print "cote manquante pour " . $substituee[0] . " au " . $date . "\n";
			    last;
			}
			my $subcote = $select_cote->fetchrow_array();
			$cote = $cote + ((($subcote * $substituee[1])/$substituee[2]) + $substituee[3]);
		    }
		    $select_substituee->finish;
		    if (!$manque) {
			$cote = sprintf("%.2f", $cote);
			$insert_cote->execute($valsub,$cote,$date)
			    or die "Impossible d'ajouter la cote de " . $valsub . "\n";
			print "sub = " . $valsub . "\t" . $cote . "\n";
			$ccount += 1;
		    }
		}
	    }
	    $select_substituees->finish;
	}
	$select_cote->finish;
    }
#    last; # debug: test sur la premire valeur seulement
} # fin de rcupration d'une valeur de la base
$select_substitution->finish;
$select_substituee->finish;
$select_valeurs->finish;
# dcompte des cotations
if ($ccount > 0) {
    # Suppression des rsultats  la date de mise  jour des cotes
    print "Rsultats supprims  partir de $maj \n";
    $delete_results->execute($maj);
    # Validation des modifications
    $pdbh->commit();
    print $ccount . " mises  jour de cotation\n";
} else {
    print "Pas de mise  jour des cotations\n";
}
#
# fin de la recherche
#
print "Cotations cherches=" . $tried ."\tNon trouves=" . $notfound . "\n";
#
# On ferme!
#
$pdbh->disconnect;
#
# Logout
#
$requete= HTTP::Request->new(GET => 'http://www.boursorama.com/deconnexion.phtml');
$cookie_jar->add_cookie_header($requete) ;
$reponse = $ua->request($requete);
# Contrle de la rponse
if ($reponse->is_success) {
} else {
        print "Erreur logout: " . $reponse->status_line . "\n";
        exit(1);
}

exit(0);


